
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _ptr_to_eeprom=R4
	.DEF _ticReadData=R7
	.DEF _flag=R6
	.DEF _ptrDataBuff=R8
	.DEF _ptrOutLCD_Buff=R10
	.DEF __lcd_x=R13
	.DEF __lcd_y=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _usartRX
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_ConvertWinFont:
	.DB  0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4
	.DB  0xA5,0xA6,0x4B,0xA7,0x4D,0x48,0x4F,0xA8
	.DB  0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB
	.DB  0xAC,0xE2,0xAD,0xAE,0x62,0xAF,0xB0,0xB1
	.DB  0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7
	.DB  0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE
	.DB  0x70,0x63,0xBF,0x79,0xE4,0x78,0xE5,0xC0
	.DB  0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7

_0x3:
	.DB  0xD3,0xF1,0xF2,0xF0,0xEE,0xE9,0xF1,0xF2
	.DB  0xE2,0xEE,0x20,0xEE,0xF2,0xEE,0xE1,0xF0
	.DB  0xE0,0xE6,0xE5,0xED,0xE8,0xFF,0x20,0xF0
	.DB  0xE5,0xEA,0xEB,0xE0,0xEC,0xED,0xEE,0xE9
	.DB  0x20,0xE8,0xED,0xF4,0xEE,0xF0,0xEC,0xE0
	.DB  0xF6,0xE8,0xE8,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20
_0x32:
	.DB  0x0,0x0,LOW(_DataBuff),HIGH(_DataBuff),LOW(_DataBuff),HIGH(_DataBuff)
_0x0:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0,0x57,0x49,0x4E,0x53,0x54,0x41,0x52
	.DB  0x20,0x44,0x49,0x53,0x50,0x4C,0x41,0x59
	.DB  0x53,0x0
_0x2000003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x3B
	.DW  _DataBuff
	.DW  _0x3*2

	.DW  0x06
	.DW  0x06
	.DW  _0x32*2

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V1.25.7 beta 5 Professional
;Automatic Program Generator
; Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 09.08.2008
;Author  : F4CG
;Company : F4CG
;Comments:
;
;Chip type           : ATmega8
;Program type        : Application
;Clock frequency     : 8,00 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x18 ;PORTB
; 0000 001D #endasm
;#include <lcd.h>
;
;// Declare your global variables here
;char eeprom *ptr_to_eeprom;
;unsigned char ticReadData=0;
;
;unsigned char flag=0;
;#define readData_0D     0x80
;#define USARTreadData   0x40
;#define str_default     0x20
;#define ENDStrDefault   0x10
;
;#define StartAdrEEPROM          0x0F
;#define DelayOutSimbol_to_LCD   400		//200 //        .
;#define maxLenStr               255
;
;
;flash unsigned char ConvertWinFont[]={0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4,0xA5,0xA6,0x4B,0xA7,
;0x4D,0x48,0x4F,0xA8,0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB,0xAC,0xE2,0xAD,0xAE,0x62,0xAF,0xB0,0xB1,
;0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE,0x70,0x63,0xBF,0x79,
;0xE4,0x78,0xE5,0xC0,0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7};
;
;char DataBuff[280]={"                   "};

	.DSEG
;char *ptrDataBuff=&DataBuff[0];
;char *ptrOutLCD_Buff=&DataBuff[0];
;
;interrupt [USART_RXC] void usartRX(void)
; 0000 0039 {

	.CSEG
_usartRX:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 003A char data;
; 0000 003B 
; 0000 003C     data=UDR;
	ST   -Y,R17
;	data -> R17
	IN   R17,12
; 0000 003D     flag |= USARTreadData;
	LDI  R30,LOW(64)
	OR   R6,R30
; 0000 003E     if (flag & readData_0D)
	SBRS R6,7
	RJMP _0x4
; 0000 003F     {
; 0000 0040         if (data==0x0A)
	CPI  R17,10
	BRNE _0x5
; 0000 0041         {
; 0000 0042             //ENDreciveStr();
; 0000 0043             for (data=0; data<16; data++)
	LDI  R17,LOW(0)
_0x7:
	CPI  R17,16
	BRSH _0x8
; 0000 0044                 *ptrDataBuff++=0x20;
	RCALL SUBOPT_0x0
	LDI  R26,LOW(32)
	STD  Z+0,R26
	SUBI R17,-1
	RJMP _0x7
_0x8:
; 0000 0046 *ptrDataBuff=0;
	MOVW R26,R8
	RCALL SUBOPT_0x1
; 0000 0047             ptrDataBuff=&DataBuff[0];
	RCALL SUBOPT_0x2
; 0000 0048             ptr_to_eeprom=0;
; 0000 0049             ptr_to_eeprom+=StartAdrEEPROM;
; 0000 004A             *ptr_to_eeprom++=0;
	RCALL SUBOPT_0x3
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
; 0000 004B 
; 0000 004C             while(*ptrDataBuff)
_0x9:
	MOVW R26,R8
	LD   R30,X
	CPI  R30,0
	BREQ _0xB
; 0000 004D                 *ptr_to_eeprom++=*ptrDataBuff++;
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x0
	LD   R30,Z
	RCALL __EEPROMWRB
	RJMP _0x9
_0xB:
; 0000 004F *ptr_to_eeprom=0;
	MOVW R26,R4
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
; 0000 0050             ptrDataBuff=&DataBuff[0];
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x2
; 0000 0051             ptr_to_eeprom=0;
; 0000 0052             ptr_to_eeprom+=StartAdrEEPROM;
; 0000 0053             ptr_to_eeprom++;
; 0000 0054             ptrOutLCD_Buff=&DataBuff[0];
	RCALL SUBOPT_0x6
; 0000 0055             lcd_gotoxy(0,1);
	RCALL SUBOPT_0x7
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_gotoxy
; 0000 0056             lcd_putsf("                ");
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_putsf
; 0000 0057             flag &= ~USARTreadData;
	LDI  R30,LOW(191)
	AND  R6,R30
; 0000 0058             ticReadData=0;
	CLR  R7
; 0000 0059         }
; 0000 005A         flag &= ~readData_0D;
_0x5:
	LDI  R30,LOW(127)
	AND  R6,R30
; 0000 005B         return;
	RJMP _0x31
; 0000 005C     }
; 0000 005D     if (data==0x0D)
_0x4:
	CPI  R17,13
	BRNE _0xC
; 0000 005E     {
; 0000 005F         flag |= readData_0D;
	LDI  R30,LOW(128)
	OR   R6,R30
; 0000 0060         return;
	RJMP _0x31
; 0000 0061     }
; 0000 0062     if (ticReadData < maxLenStr)
_0xC:
	LDI  R30,LOW(255)
	CP   R7,R30
	BRSH _0xD
; 0000 0063     {
; 0000 0064         *ptrDataBuff=data;
	MOV  R30,R17
	MOVW R26,R8
	ST   X,R30
; 0000 0065         ptrDataBuff++;
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
; 0000 0066         ticReadData++;
	INC  R7
; 0000 0067     }
; 0000 0068     else
	RJMP _0xE
_0xD:
; 0000 0069         flag &= ~readData_0D;
	LDI  R30,LOW(127)
	AND  R6,R30
; 0000 006A }
_0xE:
_0x31:
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;void beg_stroka(void)
; 0000 006D {
_beg_stroka:
; 0000 006E unsigned char i;
; 0000 006F 
; 0000 0070 //   
; 0000 0071         for(i=0;i<17;i++)
	ST   -Y,R17
;	i -> R17
	LDI  R17,LOW(0)
_0x10:
	CPI  R17,17
	BRSH _0x11
; 0000 0072             lcd_write_byte(0xC0+i,lcd_read_byte(0xC1+i));
	MOV  R30,R17
	SUBI R30,-LOW(192)
	ST   -Y,R30
	MOV  R30,R17
	SUBI R30,-LOW(193)
	ST   -Y,R30
	RCALL _lcd_read_byte
	ST   -Y,R30
	RCALL _lcd_write_byte
	SUBI R17,-1
	RJMP _0x10
_0x11:
; 0000 0075 lcd_gotoxy(15,1);
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_gotoxy
; 0000 0076 
; 0000 0077         switch (i=*ptrOutLCD_Buff)
	MOVW R26,R10
	LD   R30,X
	MOV  R17,R30
; 0000 0078         {
; 0000 0079             case 168:
	CPI  R30,LOW(0xA8)
	BRNE _0x15
; 0000 007A                 i=0xA2;
	LDI  R17,LOW(162)
; 0000 007B                 break;
	RJMP _0x14
; 0000 007C             case 184:
_0x15:
	CPI  R30,LOW(0xB8)
	BRNE _0x17
; 0000 007D                 i=0xB5;
	LDI  R17,LOW(181)
; 0000 007E                 break;
	RJMP _0x14
; 0000 007F             default:
_0x17:
; 0000 0080                 if (i>=192)
	CPI  R17,192
	BRLO _0x18
; 0000 0081                     i=ConvertWinFont[i-192];
	MOV  R30,R17
	SUBI R30,LOW(192)
	LDI  R31,0
	SUBI R30,LOW(-_ConvertWinFont*2)
	SBCI R31,HIGH(-_ConvertWinFont*2)
	LPM  R17,Z
; 0000 0082                 else
	RJMP _0x19
_0x18:
; 0000 0083                     i=*ptrOutLCD_Buff;
	MOVW R26,R10
	LD   R17,X
; 0000 0084         }
_0x19:
_0x14:
; 0000 0085 
; 0000 0086         lcd_putchar(i);
	ST   -Y,R17
	RCALL _lcd_putchar
; 0000 0087         if(!(*(++ptrOutLCD_Buff)))
	RCALL SUBOPT_0x8
	LD   R30,Z
	CPI  R30,0
	BRNE _0x1A
; 0000 0088         {
; 0000 0089             ptrOutLCD_Buff=&DataBuff[0];
	RCALL SUBOPT_0x6
; 0000 008A             if (!(flag & str_default))
	SBRC R6,5
	RJMP _0x1B
; 0000 008B                 flag |= str_default;
	LDI  R30,LOW(32)
	OR   R6,R30
; 0000 008C         }
_0x1B:
; 0000 008D }
_0x1A:
	LD   R17,Y+
	RET
;
;void init_AVR(void)
; 0000 0090 {
_init_AVR:
; 0000 0091 // Input/Output Ports initialization
; 0000 0092 // Port B initialization
; 0000 0093 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0094 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0095 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0096 DDRB=0x00;
	OUT  0x17,R30
; 0000 0097 
; 0000 0098 // Port C initialization
; 0000 0099 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 009A // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 009B PORTC=0x00;
	OUT  0x15,R30
; 0000 009C DDRC=0x00;
	OUT  0x14,R30
; 0000 009D 
; 0000 009E // Port D initialization
; 0000 009F // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00A0 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00A1 PORTD=0x00;
	OUT  0x12,R30
; 0000 00A2 DDRD=0x00;
	OUT  0x11,R30
; 0000 00A3 
; 0000 00A4 // Timer/Counter 0 initialization
; 0000 00A5 // Clock source: System Clock
; 0000 00A6 // Clock value: Timer 0 Stopped
; 0000 00A7 TCCR0=0x00;
	OUT  0x33,R30
; 0000 00A8 TCNT0=0x00;
	OUT  0x32,R30
; 0000 00A9 
; 0000 00AA // Timer/Counter 1 initialization
; 0000 00AB // Clock source: System Clock
; 0000 00AC // Clock value: Timer 1 Stopped
; 0000 00AD // Mode: Normal top=FFFFh
; 0000 00AE // OC1A output: Discon.
; 0000 00AF // OC1B output: Discon.
; 0000 00B0 // Noise Canceler: Off
; 0000 00B1 // Input Capture on Falling Edge
; 0000 00B2 // Timer 1 Overflow Interrupt: Off
; 0000 00B3 // Input Capture Interrupt: Off
; 0000 00B4 // Compare A Match Interrupt: Off
; 0000 00B5 // Compare B Match Interrupt: Off
; 0000 00B6 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00B7 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00B8 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00B9 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00BA ICR1H=0x00;
	OUT  0x27,R30
; 0000 00BB ICR1L=0x00;
	OUT  0x26,R30
; 0000 00BC OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00BD OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00BE OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00BF OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00C0 
; 0000 00C1 // Timer/Counter 2 initialization
; 0000 00C2 // Clock source: System Clock
; 0000 00C3 // Clock value: Timer 2 Stopped
; 0000 00C4 // Mode: Normal top=FFh
; 0000 00C5 // OC2 output: Disconnected
; 0000 00C6 ASSR=0x00;
	OUT  0x22,R30
; 0000 00C7 TCCR2=0x00;
	OUT  0x25,R30
; 0000 00C8 TCNT2=0x00;
	OUT  0x24,R30
; 0000 00C9 OCR2=0x00;
	OUT  0x23,R30
; 0000 00CA 
; 0000 00CB // External Interrupt(s) initialization
; 0000 00CC // INT0: Off
; 0000 00CD // INT1: Off
; 0000 00CE MCUCR=0x00;
	OUT  0x35,R30
; 0000 00CF 
; 0000 00D0 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00D1 TIMSK=0x00;
	OUT  0x39,R30
; 0000 00D2 
; 0000 00D3 // USART initialization
; 0000 00D4 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 00D5 // USART Receiver: On
; 0000 00D6 // USART Transmitter: Off
; 0000 00D7 // USART Mode: Asynchronous
; 0000 00D8 // USART Baud Rate: 9600
; 0000 00D9 UCSRA=0x00;
	OUT  0xB,R30
; 0000 00DA UCSRB=0x90;
	LDI  R30,LOW(144)
	OUT  0xA,R30
; 0000 00DB UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 00DC UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 00DD UBRRL=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
; 0000 00DE 
; 0000 00DF // Analog Comparator initialization
; 0000 00E0 // Analog Comparator: Off
; 0000 00E1 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00E2 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00E3 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00E4 }
	RET
;
;
;void main(void)
; 0000 00E8 {
_main:
; 0000 00E9 // Declare your local variables here
; 0000 00EA 
; 0000 00EB // Place your code here
; 0000 00EC 
; 0000 00ED     init_AVR();
	RCALL _init_AVR
; 0000 00EE     lcd_init(16);   // LCD module initialization
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 00EF     lcd_gotoxy(0,0);
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x7
	RCALL _lcd_gotoxy
; 0000 00F0     lcd_putsf("WINSTAR DISPLAYS");
	__POINTW1FN _0x0,17
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_putsf
; 0000 00F1     #asm("sei")
	sei
; 0000 00F2 
; 0000 00F3     while (1)
; 0000 00F4     {
; 0000 00F5         if (!(flag & str_default))
	SBRS R6,5
; 0000 00F6             break;
	RJMP _0x1E
; 0000 00F7 
; 0000 00F8         ptrOutLCD_Buff=&DataBuff[0];
	RCALL SUBOPT_0x6
; 0000 00F9         ptr_to_eeprom=0;
	RCALL SUBOPT_0x9
; 0000 00FA         ptr_to_eeprom+=StartAdrEEPROM;
; 0000 00FB         if (!(*ptr_to_eeprom++))
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xA
	BRNE _0x20
; 0000 00FC         {
; 0000 00FD             while(*ptr_to_eeprom)
_0x21:
	MOVW R26,R4
	RCALL SUBOPT_0xA
	BREQ _0x23
; 0000 00FE                 *ptrOutLCD_Buff++=*ptr_to_eeprom++;
	RCALL SUBOPT_0x8
	SBIW R30,1
	MOVW R0,R30
	RCALL SUBOPT_0x4
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	RJMP _0x21
_0x23:
; 0000 00FF *ptrOutLCD_Buff=0;
	MOVW R26,R10
	RCALL SUBOPT_0x1
; 0000 0100             ptrOutLCD_Buff=&DataBuff[0];
	MOVW R10,R30
; 0000 0101             ptr_to_eeprom=0;
	RCALL SUBOPT_0x9
; 0000 0102             ptr_to_eeprom+=StartAdrEEPROM;
; 0000 0103             ptr_to_eeprom++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
; 0000 0104         }
; 0000 0105         break;
_0x20:
; 0000 0106     }
_0x1E:
; 0000 0107 
; 0000 0108     while (1)
_0x24:
; 0000 0109     {
; 0000 010A         while (flag & USARTreadData);
_0x27:
	SBRC R6,6
	RJMP _0x27
; 0000 010B         if (!(flag & ENDStrDefault))
	SBRC R6,4
	RJMP _0x2A
; 0000 010C         {
; 0000 010D             if (flag & str_default)
	SBRS R6,5
	RJMP _0x2B
; 0000 010E             {
; 0000 010F                 flag |= ENDStrDefault;
	LDI  R30,LOW(16)
	OR   R6,R30
; 0000 0110                 ptrOutLCD_Buff=&DataBuff[0];
	RCALL SUBOPT_0x6
; 0000 0111                 ptr_to_eeprom=0;
	RCALL SUBOPT_0x9
; 0000 0112                 ptr_to_eeprom+=StartAdrEEPROM;
; 0000 0113                 if (!(*ptr_to_eeprom++))
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xA
	BRNE _0x2C
; 0000 0114                 {
; 0000 0115                     while(*ptr_to_eeprom)
_0x2D:
	MOVW R26,R4
	RCALL SUBOPT_0xA
	BREQ _0x2F
; 0000 0116                         *ptrOutLCD_Buff++=*ptr_to_eeprom++;
	RCALL SUBOPT_0x8
	SBIW R30,1
	MOVW R0,R30
	RCALL SUBOPT_0x4
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	RJMP _0x2D
_0x2F:
; 0000 0117 *ptrOutLCD_Buff=0;
	MOVW R26,R10
	RCALL SUBOPT_0x1
; 0000 0118                     ptrOutLCD_Buff=&DataBuff[0];
	MOVW R10,R30
; 0000 0119                     ptr_to_eeprom=0;
	RCALL SUBOPT_0x9
; 0000 011A                     ptr_to_eeprom+=StartAdrEEPROM;
; 0000 011B                     ptr_to_eeprom++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
; 0000 011C                 }
; 0000 011D             }
_0x2C:
; 0000 011E         }
_0x2B:
; 0000 011F         delay_ms(DelayOutSimbol_to_LCD);
_0x2A:
	LDI  R30,LOW(400)
	LDI  R31,HIGH(400)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0120         beg_stroka();
	RCALL _beg_stroka
; 0000 0121     }
	RJMP _0x24
; 0000 0122 }
_0x30:
	RJMP _0x30
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G100:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G100
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G100
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G100
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G100
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G100:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G100
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G100
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G100
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G100
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2020001
_lcd_write_byte:
	RCALL __lcd_ready
	LDD  R30,Y+1
	RCALL SUBOPT_0xB
	RCALL __lcd_ready
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	RCALL SUBOPT_0xB
	RJMP _0x2020002
__lcd_read_nibble_G100:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G100
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G100
    andi  r30,0xf0
	RET
_lcd_read_byte0_G100:
	RCALL __lcd_delay_G100
	RCALL __lcd_read_nibble_G100
    mov   r26,r30
	RCALL __lcd_read_nibble_G100
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_read_byte:
	RCALL __lcd_ready
	LD   R30,Y
	RCALL SUBOPT_0xB
	RCALL __lcd_ready
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rs     ;RS=1
	RCALL _lcd_read_byte0_G100
	RJMP _0x2020001
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0xB
	LDD  R13,Y+1
	LDD  R12,Y+0
_0x2020002:
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0xB
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0xB
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(0)
	MOV  R12,R30
	MOV  R13,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_maxx
	CP   R13,R30
	BRLO _0x2000004
	__lcd_putchar1:
	INC  R12
	RCALL SUBOPT_0x7
	ST   -Y,R12
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2000004:
	INC  R13
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	RJMP _0x2020001
_lcd_putsf:
	ST   -Y,R17
_0x2000008:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x200000A
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2000008
_0x200000A:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G100:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G100:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G100
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2020001
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xC
	RCALL __long_delay_G100
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G100
	RCALL __long_delay_G100
	LDI  R30,LOW(40)
	RCALL SUBOPT_0xB
	RCALL __long_delay_G100
	LDI  R30,LOW(4)
	RCALL SUBOPT_0xB
	RCALL __long_delay_G100
	LDI  R30,LOW(133)
	RCALL SUBOPT_0xB
	RCALL __long_delay_G100
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G100
	CPI  R30,LOW(0x5)
	BREQ _0x200000B
	LDI  R30,LOW(0)
	RJMP _0x2020001
_0x200000B:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0xB
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x2020001:
	ADIW R28,1
	RET

	.DSEG
_DataBuff:
	.BYTE 0x118
__base_y_G100:
	.BYTE 0x4
__lcd_maxx:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   X,R30
	LDI  R30,LOW(_DataBuff)
	LDI  R31,HIGH(_DataBuff)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2:
	MOVW R8,R30
	CLR  R4
	CLR  R5
	MOVW R30,R4
	ADIW R30,15
	MOVW R4,R30
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	SBIW R30,1
	MOVW R26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x4:
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(_DataBuff)
	LDI  R31,HIGH(_DataBuff)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	RCALL SUBOPT_0x5
	MOVW R10,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x8:
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x9:
	CLR  R4
	CLR  R5
	MOVW R30,R4
	ADIW R30,15
	MOVW R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	RCALL __EEPROMRDB
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xB:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xC:
	RCALL __long_delay_G100
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G100


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
